package com.loafle.bridge.discoveryzone;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.loafle.bridge.discoveryhistory.DiscoveryHistory;
import com.loafle.bridge.discoveryhost.DiscoveryHost;

import javax.persistence.*;
import java.util.Date;
import java.util.List;

/**
 * Created by root on 16. 11. 15.
 */
@Entity
public class DiscoveryZone {


    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private long id;

    @Column(nullable=false)
    private long ip;

    @Column(nullable=false)
    private short mask;

    @Column(nullable=false)
    private String iface;

    @Column(nullable=false)
    private long mac;

    @Column(nullable=false)
    private long firstScanRange;

    @Column(nullable=false)
    private long lastScanRange;

    public short getMask() {
        return mask;
    }

    public void setMask(short mask) {
        this.mask = mask;
    }

    public String getIface() {
        return iface;
    }

    public void setIface(String iface) {
        this.iface = iface;
    }

    public long getMac() {
        return mac;
    }

    public void setMac(long mac) {
        this.mac = mac;
    }

    public long getFirstScanRange() {
        return firstScanRange;
    }

    public void setFirstScanRange(long firstScanRange) {
        this.firstScanRange = firstScanRange;
    }

    public long getLastScanRange() {
        return lastScanRange;
    }

    public void setLastScanRange(long lastScanRange) {
        this.lastScanRange = lastScanRange;
    }

    @JoinColumn(nullable=false)
    @OneToOne
    @JsonIgnore
    private DiscoveryHistory discovery;

    @OneToMany(mappedBy = "zone", cascade = CascadeType.ALL)
    private List<HostScanHistory> histories;

    @OneToMany(mappedBy = "zone", cascade = CascadeType.ALL)
    private List<DiscoveryHost> hosts;

    @Column(columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", nullable = false, insertable = false, updatable = false)
    private Date createDate;

    @Column(columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", nullable = false, insertable = false)
    private Date updateDate;

    public Date getCreateDate() {
        return createDate;
    }

    public void setCreateDate(Date createDate) {
        this.createDate = createDate;
    }

    public Date getUpdateDate() {
        return updateDate;
    }

    public void setUpdateDate(Date updateDate) {
        this.updateDate = updateDate;
    }

    public List<HostScanHistory> getHistories() {
        return histories;
    }

    public void setHistories(List<HostScanHistory> histories) {
        this.histories = histories;
    }



    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    public long getIp() {
        return ip;
    }

    public void setIp(long ip) {
        this.ip = ip;
    }

    public DiscoveryHistory getDiscovery() {
        return discovery;
    }

    public void setDiscovery(DiscoveryHistory discovery) {
        this.discovery = discovery;
    }


    public List<DiscoveryHost> getHosts() {
        return hosts;
    }

    public void setHosts(List<DiscoveryHost> hosts) {
        this.hosts = hosts;
    }

    public void mappingChildren(DiscoveryHistory history) {
        this.setDiscovery(history);
        List<HostScanHistory> hostScanHistories = this.getHistories();
        if (hostScanHistories != null) {
            for (int i =0 ; i < hostScanHistories.size() ; ++i) {
                hostScanHistories.get(i).setZone(this);
            }
        }

        List<DiscoveryHost> hosts = this.getHosts();
        if (hosts != null) {
            for (int i =0 ; i < hosts.size() ; ++i) {
                hosts.get(i).mappingChildren(this);
            }
        }
    }
}
